#!/bin/sh

APPS_NAME="DSL API"
ORIG_ARGS=$@

if [ -e sysconfig.sh ]; then
	. sysconfig.sh
	. config.sh
	. model_config.sh
else
        echo "Application "$APPS_NAME" not configured"
        exit 0
fi
display_info "----------------------------------------------------------------------"
display_info "------------------------     build $APPS_NAME  -----------------------"
display_info "----------------------------------------------------------------------"

./build_platform_driver.sh $ORIG_ARGS
ifx_error_check $?
if [ $? -ne 0 ]; then
	display_error "Build DSL CPE API failed!"
	cd ..
	exit 1
fi

./build_platform_app.sh $ORIG_ARGS
ifx_error_check $?
if [ $? -ne 0 ]; then
	display_error "Build DSL CPE Control Utility failed!"
	cd ..
	exit 1
fi

mkdir -p ${BUILD_ROOTFS_DIR}/usr/sbin/
cp -af dsl_cpe_control/scripts/dsl_cpe_pipe.sh ${BUILD_ROOTFS_DIR}/usr/sbin/.

