#ifndef __IFX_PPA_INTERFACE_H
#define __IFX_PPA_INTERFACE_H


/******************************************************************************
**
** FILE NAME    : ifx_ppa_interface.h
** PROJECT      : Amazon-SE
** MODULES      : PPA 
**
** DATE         : 11 FEB 2008
** AUTHOR       : Santosh Gowda 
** DESCRIPTION  : Data strctures shared by Directpath implemenation and CPU bound device drivers.
** COPYRIGHT    :   Copyright (c) 2006
**          Infineon Technologies AG
**          Am Campeon 1-12, 85579 Neubiberg, Germany
**
**   Any use of this software is subject to the conclusion of a respective
**   License agreement. Without such a License agreement no rights to the
**   software are granted
**
** HISTORY
** $Date        $Author         $Comment
** 11 FEB 2008  Santosh Gowda   Initiate Version
*******************************************************************************/

/*
 *  Chip Specific Head File
 */
#if defined(CONFIG_DANUBE_PPA) || defined(CONFIG_DANUBE_PPA_MODULE)
  #include <asm/danube/ifx_ppa_api.h>
#elif defined(CONFIG_IFX_PPA) || defined(CONFIG_IFX_PPA_MODULE)
  #include <asm/amazon_se/ifx_ppa_api.h>
#endif

typedef int32_t (*PPA_FP_RX_FN) (PPA_NETIF *rx_if, PPA_NETIF *tx_if, PPA_BUF *ppa_buf, int32_t len);
typedef int32_t (*PPA_FP_RESTART_TX_FN) (PPA_NETIF *dev);
typedef int32_t (*PPA_FP_STOP_TX_FN) (PPA_NETIF *dev);

typedef struct {
    /* Tx callback */
    PPA_FP_STOP_TX_FN 		stop_tx_fn;
    PPA_FP_RESTART_TX_FN 	start_tx_fn;

    /* Rx callback */
    PPA_FP_RX_FN 		rx_fn;

} PPA_DIRECTPATH_CB;

/*
 * ####################################
 *             Declaration
 * ####################################
 */

#endif

